summaryrefslogtreecommitdiffstats
path: root/lib/locale.sh
diff options
context:
space:
mode:
authorP. J. McDermott <pjm@nac.net>2013-10-23 13:10:46 (EDT)
committer P. J. McDermott <pjm@nac.net>2013-10-23 13:10:46 (EDT)
commitb4dab93d7fb39b4e92886a06260eeaa3bf759337 (patch)
tree0c55bd84e69d4f334864f7a7d12c6f2fa290a169 /lib/locale.sh
parent78f780c8f00ea98f8d2503bb4fb5c9488f0f4507 (diff)
lib/locale.sh: New file.
Diffstat (limited to 'lib/locale.sh')
-rw-r--r--lib/locale.sh93
1 files changed, 93 insertions, 0 deletions
diff --git a/lib/locale.sh b/lib/locale.sh
new file mode 100644
index 0000000..943d02f
--- /dev/null
+++ b/lib/locale.sh
@@ -0,0 +1,93 @@
+# ProteanOS Development Kit
+# lib/locale.sh
+# Locale functions
+#
+# Copyright (C) 2012, 2013 Patrick "P. J." McDermott
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+[ "x${_LOCALE_SM+set}" = 'xset' ] && return 0
+_LOCALE_SM=1
+
+LOCALEDIR='@localedir@'
+LOCALE_PATH='%s/%s/LC_MESSAGES/%s.ms:%s/%s/%s.ms'
+DEFAULT_LOCALE='en_US'
+TEXT_DOMAIN='@textdomain@'
+
+load_locale()
+{
+ local localedir=
+ local localepath=
+
+ # Make sure LC_MESSAGES is set.
+ if [ "x${LC_MESSAGES+set}" != 'xset' ]; then
+ if [ "x${LC_ALL+set}" = 'xset' ]; then
+ LC_MESSAGES="${LC_ALL}"
+ elif [ "x${LANG+set}" = 'xset' ]; then
+ LC_MESSAGES="${LANG}"
+ else
+ LC_MESSAGES="${DEFAULT_LOCALE}"
+ fi
+ fi
+
+ localedir="${LOCALEDIR}"
+ localepath="${LOCALE_PATH}"
+
+ # Try to load the locale.
+ if ! _try_load_locale "${localedir}" "${localepath}" \
+ "${LC_MESSAGES%.*}"; then
+ if ! _try_load_locale "${localedir}" "${localepath}" \
+ "${LC_MESSAGES%_*}"; then
+ if ! _try_load_locale "${localedir}" "${localepath}" \
+ "${DEFAULT_LOCALE}"; then
+ warn 'Cannot load locale'
+ return 1
+ fi
+ fi
+ fi
+
+ return 0
+}
+
+get_msg()
+{
+ local msgid="${1}"
+
+ eval "printf '%s' \"\${msg_${TEXT_DOMAIN}_${msgid}}\""
+
+ return 0
+}
+
+_try_load_locale()
+{
+ local localedir="${1}"
+ local localepath="${2}"
+ local locale="${3}"
+ local path=
+ local ms=
+
+ IFS=':'
+ for path in ${localepath}; do
+ unset IFS
+ ms="$(printf "${path}" \
+ "${localedir}" "${locale}" "${TEXT_DOMAIN}")"
+ if [ -f "${ms}" ]; then
+ . "${ms}"
+ return 0
+ fi
+ done
+ unset IFS
+
+ return 1
+}